#include "Pipe.h"

SendPipe::SendPipe(STRING output)
{
	forSend = open(output.c_str(), O_WRONLY);
	
	//TODO Exceptio handling
	if(forSend == -1)
	{
		printf("Cannot open pipes");
		throw Exception("Cannot open pipes");
	}		
}

SendPipe::~SendPipe()
{
	close(forSend);
}

void SendPipe::send(Message m)
{
	int type = m.getType();
	int acked = m.getAcked();
	int value = m.getValue();
	long timestamp = m.getTimeStamp();
	
	*((int *)writebuf) = type;
	*( (int *) (writebuf + sizeof(int)) ) = acked;
	*( (int *) (writebuf + 2 * sizeof(int)) ) = value;
	*( (long *) (writebuf + 3 * sizeof(int)) ) = timestamp;
	
	write(forSend, writebuf, MYBUF);	
}

ReceivePipe::ReceivePipe(STRING input)
{
	forReceive = open(input.c_str(), O_RDONLY);
	
	//TODO Exceptio handling
	if(forReceive == -1)
	{
		printf("Cannot open pipes");
		throw Exception("Cannot open pipes");
	}		
}

ReceivePipe::~ReceivePipe()
{
	close(forReceive);
}

Message ReceivePipe::receive()
{
	int type = 0;
	int acked = 0;
	int value = 0;
	long timestamp = 0;

	read(forReceive, readbuf, MYBUF);
	
	type = *((int *)readbuf);
	acked = *( (int *) (readbuf + sizeof(int)) );
	value = *( (int *) (readbuf + 2 * sizeof(int)) );
	timestamp = *( (long *) (readbuf + 3 * sizeof(int)) );
	
	return Message(type, acked, value, timestamp);
}

