#include <unistd.h>
#include <sys/types.h>
#include <signal.h>

#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include "Pipe.h"
#include "Message.h"
#include "ReceiverSlidingWindow.h"

#define	COUT	std::cout
#define	CIN		std::cin
#define READDEL	500000
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
sem_t sem;
ReceiverSlidingWindow receiverSlidingWindow ;

ReceivePipe receiver("NETSNDTODEST");
SendPipe sender("NETRECFMDEST");

int x, y;

int the_clock = 0;

void timer(int signum)
{
	the_clock++;
}

void * read_thread(void * parameter)
{
//	for(int i = 0; i < 10; i++)
	int i = 0 ;
	while (true)
	{
		COUT << "--------------------Reading Msg --------------\n";
		usleep( READDEL);
		receiverSlidingWindow.readMessage(i);
		
		if(i < receiverSlidingWindow.getNextMessageExpected())
			i++;
		
		if ( i > bufferSize )
			break;
	}	
	return NULL;
}

void * sender_thread(void * parameter)
{	
	while (true )
	{
		COUT << "-----------Sending Msg------------------\n";
		COUT << "expected : "<<receiverSlidingWindow.getNextMessageExpected() << "\n";
		COUT << "read : " << receiverSlidingWindow.getLastByteRead()<<"\n";
		COUT << "advWindow is " << receiverSlidingWindow.getAdvWindow() << "\n";		
		pthread_mutex_lock(&mutex);//{
		sender.send(Message(1, receiverSlidingWindow.getNextMessageExpected()  ,receiverSlidingWindow.getAdvWindow() , the_clock ) );
		pthread_mutex_unlock(&mutex);//}
		//		sender.send(Message(1, m.getValue()+1, 20, 0))
		sleep(1);
		COUT << "-----------------------------\n";
	}
	return NULL;
}

void * receiver_thread123(void * parameter)
{
	
	
//	printf("Received: %s", receiver.receive().toString().c_str());
////	sem_post (&sem);
	while (true )
	{
//		COUT << "----------------------->in the receiver thread\n";
		Message msg = receiver.receive();
		receiverSlidingWindow.receiveMessage(msg.getValue());
		printf("received: %s", msg.toString().c_str());
		COUT << "expected : "<<receiverSlidingWindow.getNextMessageExpected() << "\n";
		COUT << "read : " << receiverSlidingWindow.getLastByteRead()<<"\n";
		COUT << "advWindow is " << receiverSlidingWindow.getAdvWindow() << "\n";		
		pthread_mutex_lock(&mutex);//{
		sender.send(Message(1, receiverSlidingWindow.getNextMessageExpected()  ,receiverSlidingWindow.getAdvWindow() , the_clock ) );
		pthread_mutex_unlock(&mutex);//}
		//CIN >> tmp;

	}

//	sem_wait (&sem);
	return NULL;
}

void init()
{
	sem_init (&sem, 0, 0);
	srand( time(0) + 1);

	y = rand() % 20;
	
	signal(SIGUSR1, &timer);

	{
		SendPipe PIDSender("RECEIVERTELLPID");
		
		Message m( 0, 0, 0, getpid());
		PIDSender.send(m);
		printf("PID: %ld\n", m.getTimeStamp());	
	}	
}

int main(int argc, char *argv[])
{
	init();
	
	Message m = receiver.receive();
	x = m.getValue();
	
	sender.send(Message( 0, x + 1, y, 0));
	
	m = receiver.receive();
	
	printf("x: %d, y: %d\n", x, y);	
	
//	while(true)
//	{
//		Message m = receiver.receive();
//		printf("Received: %s", m.toString().c_str());
//		sender.send(Message(1, m.getValue()+1, 20, 0));// i suppose that the value keep the amount of advertisement window.
//	}				
				
	pthread_t for_send;
	pthread_t for_receive;
	pthread_t for_read ;
		
	pthread_create(&for_read, NULL, &read_thread, NULL);
	pthread_create(&for_receive, NULL, &receiver_thread123, NULL);
	pthread_create(&for_send, NULL, &sender_thread, NULL);


	pthread_join(for_send, NULL);
	pthread_join(for_receive, NULL);
	pthread_join(for_read, NULL);
	

	return 0;
}
