#include "SenderSlidingWindow.h"
#include <semaphore.h>
#define	COUT		std::cout

extern int the_clock;

pthread_mutex_t sliding_window_mutex = PTHREAD_MUTEX_INITIALIZER;

SenderSlidingWindow::SenderSlidingWindow() : congwin(LIMIT)
{
//	effectiveWin.open("effectiveWin.xls");
	congestionWin.open("congestionWin.xls");
//	advertisedWin.open("advertisedWin.xls");

	for (int i = 0 ; i < bufferSize ; i++)
	{
		buffer[i].setValue(10);//-10 for initializing
	}
	
//	sliding_window_mutex = PTHREAD_MUTEX_INITIALIZER;
//	congwin = new AIMD (bufferSize);
//	congwin = AIMD(bufferSize) ;
	lastByteAcked = 0 ;
	lastByteSent = 0;
	lastByteWritten = bufferSize;//-1 ;
	sem_init (&sem1, 0, 0);	
	advertisementWinSize = 5;
	currentTime = 0 ;
	waited =false;
	estimatedRTT = 0;
	sampleRTT = 100;
	alpha = 0.8;
	RTT = 30;
}

SenderSlidingWindow::~SenderSlidingWindow()
{
//	effectiveWin.close();
	congestionWin.close();
//	advertisedWin.close();
}

void SenderSlidingWindow::setLastByteAcked(int a )
{
	lastByteAcked = a ;
}
void SenderSlidingWindow::setLastByteSent(int a)
{
	lastByteSent = a;	
}
void SenderSlidingWindow::setLastByteWritten(int a )
{
	lastByteWritten = a;	
}
void SenderSlidingWindow::setRTT()
{
	
	//try to calulate the RTT.
}
void SenderSlidingWindow::setCongWin (WINDOWTYPE a)
{
	congwin = a;	
}
WINDOWTYPE& SenderSlidingWindow::getCongWin()
{
	return congwin;
}
void SenderSlidingWindow::setRTT(int newRTT)
{
	RTT = newRTT;
}
void SenderSlidingWindow::gottenAck (int index , int advWin )
{
	congwin.packetAcked();
	
	COUT << "received index is : "<< index <<"\n";
	COUT <<"advWindow is : " << advWin<<"\n";
	setAdvertisementWinSize (advWin);
	calcRTT(index);
	
	for ( int h = lastByteAcked ; h < index ; h ++ )
	{

		if (buffer[h].getValue() >0 )
			buffer[h ].setValue(-1);
		else 
		{
			buffer[h].setValue(buffer[h].getValue() - 1);//decrease by one to keep number of the received ack.
			if (buffer[h].getValue()==-3)
			{
				congwin.receivedDupAck();
				
				if(congwin.ifAutoReSend())
				{
					buffer[h].setTimeSlice(0);
				}
			}
		}	
	}	
	//Below code checks if there is culumative ack or not .
	
	COUT << "lastByteAcked : "<<lastByteAcked << "\nlastByteSent  :"<<lastByteSent<<"\n";
	bool isLAstByteAckedChange =true;
	if ( lastByteAcked >= lastByteSent)
	{
		isLAstByteAckedChange = false; 
		COUT << " The lastByteAcked not changed.\n";
	}
	
	//COUT << "lastByteAcked"<<lastByteAcked <<"\n index : " << index <<"\n";
//	for (int i = lastByteAcked ; i< index ; i++)
//	{
//		if (buffer[index].getValue()!= -1 )
//		{
//			isLAstByteAckedChange = false;
//			break;
//		}
//	}


	if (isLAstByteAckedChange)
	{
		int culumativeAckSize = ( index -   lastByteAcked);	
		/**
		 *@todo make it  better later. 
		*/
		if (index >0 )
			lastByteAcked = index ;
		
		
		pthread_mutex_lock(&sliding_window_mutex);//{
		calcEffeciveWindow();	
		if (waited && effectiveWindowSize > 0)
		{
			waited =false;		
			pthread_mutex_unlock(&sliding_window_mutex);//}
			sem_post (&sem1);				
		}
		else
		{
			pthread_mutex_unlock(&sliding_window_mutex);//}		
		}	
		
//		for (int i = 0 ; i < culumativeAckSize ; i++ )
//			sem_post(numberToSend);
	}				
	

	
	
}
void SenderSlidingWindow::incWriteByte()
{
	int tmp = (lastByteWritten +1 )% bufferSize;
	buffer [tmp].setValue(1) ;
}
void SenderSlidingWindow::sentByte(int index)
{
	buffer[index].setValue(0);
}

void SenderSlidingWindow::calcEffeciveWindow()
{
	int CWSize = congwin.getSize();
	int MinWin = (CWSize < advertisementWinSize ? (CWSize):(advertisementWinSize));	
	
	if(MinWin > LIMIT)
	{
		MinWin = LIMIT;
		COUT << "The current cong-advertised window is bigger than my own limit.\n";
	}
	
	COUT << "\n cwsize "<< CWSize << "\nMinWin : " << MinWin << "\n lastByteSent : "<<lastByteSent << "\nlastByteAcked" << lastByteAcked<<"\n";
	effectiveWindowSize = MinWin- ((lastByteSent -1)- lastByteAcked);
		
//	effectiveWin << the_clock << '\t' << effectiveWindowSize << '\n';
//	effectiveWin.flush();
	congestionWin << the_clock << '\t' << CWSize << '\n';
	congestionWin.flush();
//	advertisedWin << the_clock << '\t' << advertisementWinSize << '\n';
//	advertisedWin.flush();
	
	//Now try to send the packets which are timed out .
	
	for (int i = lastByteAcked; i < lastByteSent ; i++ )
	{		
		COUT << "------------>i : " << i << " timeSlice"<<buffer[i].getTimeSlice() << "\n";
		if ( buffer[i].getTimeSlice() <=0 )
		{	
			effectiveWindowSize++;
		}
	}	
	COUT << "Effective win is : "<< effectiveWindowSize<<"\n";
	return ;	
}

BufferItemVECTOR  SenderSlidingWindow::whatToSend()
{

//	COUT <<"************************in the whatToSend*******\n";
	//First we must erase all the content of the vector.
	whatToSendVect.resize(0);	
	
	pthread_mutex_lock(&sliding_window_mutex);//{
	calcEffeciveWindow();
	
	if (effectiveWindowSize <=  0)
	{
		waited =true ;		
		pthread_mutex_unlock(&sliding_window_mutex);//}
		COUT << "---------------------------------------------------------------->sender is Waiting\n";
		sem_wait (&sem1);				
		COUT << "---------------------------------------------------------------->sender has already wake up by receiver\n";
	}
	else
	{
		pthread_mutex_unlock(&sliding_window_mutex);//}		
	}	
	
	
	COUT << "the value of lastbyteack : "<<lastByteAcked<<"\n the value of lastbyteSent : "<<lastByteSent <<"\n";
	if (lastByteSent < lastByteAcked  )
	{
		COUT <<"+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
		COUT <<"OOPS lastbyteacked is less than lastbytesent\n";
		COUT <<"+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	}
	for (int i = lastByteAcked; i < lastByteSent ; i++ )
	{
		
		COUT << "------------>i : " << i << " timeSlice"<<buffer[i].getTimeSlice() << "\n";
		if ( buffer[i].getTimeSlice() <=0 )
		{			
			congwin.timedOut();
			
			COUT <<"----------------Before Retransmission----------------------------\n";
			COUT << "\ni is : " << i <<"\n";
			COUT << "the value of timeSlice is "<<buffer[i].getTimeSlice() ;
			COUT << "\nthe amount of value is "<<buffer[i].getValue()<<"\n";
			COUT <<"----------------------------------------------------------\n";
			
			buffer[i].setTimeSlice(RTT);
			buffer[i].setStartTime(currentTime);
			buffer[i].setSeqNO(i);
			whatToSendVect.push_back(buffer[i]);			
			
			COUT <<"----------------After Retransmission----------------------------\n";
			COUT << "\ni is : " << i <<"\n";
			COUT << "the value of timeSlice is "<<buffer[i].getTimeSlice() ;
			COUT << "\nthe amount of value is "<<buffer[i].getValue()<<"\n";
			COUT <<"----------------------------------------------------------\n";

		}
	}
		
	int counter = 0 ;
//	lastByteSent ++;
	//Second try to make the sender to send the packets which are written.
	for ( int j = lastByteSent ;j < lastByteWritten; j++)
	{
	
		lastByteSent = (lastByteSent + 1 ) %  bufferSize;
		buffer[j].setTimeSlice(RTT);
		buffer[j].setStartTime(currentTime);
		buffer[j].setSeqNO(j);
		whatToSendVect.push_back(buffer[j]);	
//		COUT <<"-------------------must sent----------------\n";
//		COUT << "\ni is : " << j <<"\n";
//		COUT << "the value of timeSlice is "<<buffer[j].getTimeSlice() ;
//		COUT << "\nthe amount of value is "<<buffer[j].getValue()<<"\n";
//		COUT <<"----------------------------------------------------------\n";
		
		
//********************** It's upper now!
		counter++;
		if ( counter >= effectiveWindowSize )
		{									
			return whatToSendVect;
		}
	}
	
	return whatToSendVect;
}

void SenderSlidingWindow::setAdvertisementWinSize(int a )
{
	advertisementWinSize = a;
}
int SenderSlidingWindow::getAdvertisementWinSize()
{
	return advertisementWinSize;
}
int SenderSlidingWindow::calcRTT(int index)
{
	
	int sampleRTT = currentTime - buffer[index].getStartTime();
	/**
	 *@todo try to make it out of hard code. 
	 * 
	*/
	alpha = 0.9;
//	COUT << "\nalpha is : "<<alpha <<"\n"<<"   estimatedRTT"<<estimatedRTT<<"\n";	
	estimatedRTT = alpha *(estimatedRTT)+(1-alpha)*sampleRTT ;
	
	RTT = 2* estimatedRTT;
	
//	if(RTT < 30)
//		RTT = 30;
	
	COUT << "\nSampleeRTT "<< sampleRTT<< " \n-------------->RTT : "<< RTT<<"\n";
	COUT << "RTT is : " <<RTT <<"\n";
	return RTT;
}
void SenderSlidingWindow::Tick(){
	currentTime++;
	for (int i = lastByteAcked ; i< lastByteSent ; i++)
	{
		buffer[i].decreaseTimeSlice();
	}
	
}
