#ifndef SENDERSLIDINGWINDOW_H
#define SENDERSLIDINGWINDOW_H

#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "BufferItem.h"
#include "CongestionWindow.h"
#include <vector>
#define	BufferItemVECTOR	std::vector<BufferItem>
#define	COUT		std::cout

#define WINDOWTYPE	SSAIMDFRFR
#define LIMIT	1000

const int bufferSize = 100000;

class SenderSlidingWindow{
	
private :
	int lastByteAcked ;
	int lastByteSent ;
	int lastByteWritten  ;
	BufferItemVECTOR whatToSendVect;
	int RTT ;
	int effectiveWindowSize ;
	int advertisementWinSize ;
	WINDOWTYPE congwin;
	double RTTSigma ;
	long currentTime ;
	sem_t sem1 ;
	sem_t numberToSend ;
	bool waited ;
	double estimatedRTT  ;
	double sampleRTT;
	double alpha ;

//	std::ofstream effectiveWin;
	std::ofstream congestionWin;
//	std::ofstream advertisedWin;


//	pthread_mutex_t sliding_window_mutex;
		
	BufferItem buffer [bufferSize]; 
							 // 1 means write 
							 // 0 means sent 							 
	                         // -1 means ack 
	                         // -2 means ack of that item has arrived two times
	                         // -3 means ack of that item has arrived three times
	                         // 10 means not write yet .
	                         
public:



	void setLastByteAcked(int );
	void setLastByteSent(int );
	void setLastByteWritten(int );
	void setRTT ();
	void setRTT(int );
	void setCongWin (WINDOWTYPE );
	void setEffectiveWindow(int );	
	void calcEffeciveWindow();
	void setAdvertisementWinSize (int );
	
	void gottenAck (int index , int advWin);
	void incWriteByte();
	void sentByte(int );
	void getRTT();
	WINDOWTYPE& getCongWin();
	int getEffectiveWindow();
	int getAdvertisementWinSize();
	int calcRTT(int );
	void Tick();
	
	BufferItemVECTOR whatToSend ();
	
	
	SenderSlidingWindow();	
	virtual ~SenderSlidingWindow();
};

#endif // SENDERSLIDINGWINDOW_H
